import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;


/**
 * Eine Schrankwand, die manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version  (feb 11)
 */
public class Schrankwand extends Moebel
{
    
    private Schrank schrank1, schrank2, schrank3;
    
    /**
     * Erzeuge eine neue Schrankwand mit einer Standardfarbe und Standardgroesse
     * an einer Standardposition. (Standardkonstruktor)
     */
    public Schrankwand() {
        xPosition = 10;
        yPosition = 10;
        farbe = "schwarz";
        orientierung = 0;
        istSichtbar = false;
        breite = 3*60;
        tiefe  = 37;
        initSchraenke();
    }
    
    /**
     * Erzeuge eine neue Schrankwand.
     * Konstruktor, bei dem alle Attribute gesetzt werden können.
     */
    public Schrankwand(int xPosition,
                int yPosition,
                String farbe,
                int orientierung,
                int breite,
                int tiefe) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.farbe = farbe;
        this.orientierung = orientierung;
        istSichtbar = false;
        this.breite = breite;
        this.tiefe  = tiefe;
        initSchraenke();
    }
    
    /**
     * initialisiert die Schrankobjekte.
     * Das sollte im Konstruktor geschehen,  wird aber wegen der zwei Konstruktoren
     * in eine eigene Methode ausgegliedert.
     */
    private void initSchraenke(){
        schrank1= new Schrank(0, 0, farbe, 0, breite/3, tiefe);
        schrank2= new Schrank(breite/3, 0, farbe, 0, breite/3, tiefe);
        schrank3= new Schrank(2*breite/3, 0, farbe, 0, breite/3, tiefe);
    }
    
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
     */
    protected Shape gibAktuelleFigur() {
        // einen GeneralPath definieren
        GeneralPath schrankwand = new GeneralPath();
        schrankwand.append(schrank1.gibAktuelleFigur(), false);
        schrankwand.append(schrank2.gibAktuelleFigur(), false);
        schrankwand.append(schrank3.gibAktuelleFigur(), false);
        return transformiere(schrankwand);
    }
}
