import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.ArrayList;
import java.util.Collections;


public class TextDatei
{
  private String dateiName;
  private ArrayList<String> text;
  private int aktuellerIndex;

  public TextDatei()
  {
     super();
     dateiName = "muster.txt";
     text = new ArrayList<String>();
     aktuellerIndex=-1;
  }

  /**
   * Dateinamen setzen (Ein- und Ausgabe)
   */
  public void setzeDateiNamen(String name){
      dateiName=name;
  }

  /**
   * Der vorhandene Text wird in die Datei geschrieben.
   * ACHTUNG: bestehende Dateien werden berschrieben !!!
   */
  public void dateiSchreiben(){
    if (!dateiName.equals("muster.txt"))
    {
      try {
          PrintWriter ausgabe
          = new PrintWriter(new BufferedWriter(new FileWriter(dateiName)));
          for (int i=0; i<text.size();i++) {
              ausgabe.write(text.get(i));
              if (i<text.size()-1) ausgabe.write("\n");
          }
          ausgabe.close();
      } catch (IOException e){
          System.out.println("Fehler beim Erstellen der Datei !");
      }
    }
  }

  /**
   * Der Text wird aus der Datei gelesen.
   * Der aktuelle Inhalt wird gelscht.
   */
  public void dateiLesen(){
    if (!dateiName.equals("muster.txt"))
    {
      try {
          BufferedReader eingabe
          = new BufferedReader(new FileReader(dateiName));
          String zeile;
          text.clear();
          while ((zeile = eingabe.readLine()) != null){
              text.add(zeile);
          }
          eingabe.close();
      } catch (IOException e){
          System.out.println("Fehler beim Lesen der Datei !");
      }
    }
  }

  /**
   * Verlngert das Text - Array um einen String
   */
  public void anhaengen(String neu)
  {
      text.add(neu);
      aktuellerIndex=text.size()-1;
  }

  /**
   * Lscht das Text - Array
   */
  public void loescheAlle()
  {
      text.clear();
      aktuellerIndex=-1;
  }

  /**
   * loescht den String an der aktuellen Position
   */
  public void loesche(){
    if ((aktuellerIndex>-1)&&(aktuellerIndex<text.size())) {
      text.remove(aktuellerIndex);
      if (aktuellerIndex>=text.size()) aktuellerIndex=text.size()-1;
    }
  }

  /**
   * gibt den String an der aktuellen Position zurck
   */
  public String aktuellerWert(){
    if (aktuellerIndex==-1) return new String("");
    else if (aktuellerIndex<text.size()) return text.get(aktuellerIndex);
    else return new String("");
  }

  /**
   * setzt den aktuellen Index zurck
   */
  public void zurueck(){
    if (aktuellerIndex>0) aktuellerIndex--;
  }

  /**
   * setzt den aktuellen Index weiter
   */
  public void weiter(){
    if (aktuellerIndex<text.size()-1) aktuellerIndex++;
  }

  /**
   * sortiert die Datei
   */
  public void sortiere(){
    Collections.sort(text);
  }

}

