import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.ArrayList;


/**
 * Ein Tisch, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version (20.05.07)
 */
public class Tischgruppe extends Gruppe
{
    private int anzahl;
    
    /**
    * Erzeuge eine neue Tischgruppe mit einer Standardfarbe an einer
    * Standardposition.
    * anzahl ist die Zahl der Stuehle, die an die Laengsseite passen.
    */
    public Tischgruppe(int anzahl)
    {
        super(40, 40, "blau", 0);
        this.anzahl=anzahl;
        if (anzahl<1) this.anzahl=1;
        if (anzahl>5) this.anzahl=5;
        init();
    }
  
    /**
    * erzeugt die Elemente.
    */
    protected void init() {
        super.init();
        fuegeHinzu(new Tisch(50, 50, "orange", orientierung, anzahl*60, 60));
        fuegeHinzu(new Stuhl(0, 60, farbe, orientierung+270, 40, 40));
        fuegeHinzu(new Stuhl(50+anzahl*60+10, 60, farbe, orientierung+90, 40, 40));
        for (int i=0;i<anzahl;i++){
            fuegeHinzu(new Stuhl(60+i*60, 0, farbe, orientierung, 40, 40));
            fuegeHinzu(new Stuhl(60+i*60, 120, farbe, orientierung+180, 40, 40));
        }
        
    }
    
}
