import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Arc2D;


/**
 * Ein Grundriss fuer den Raumplaner
 * 
 * @author Claus Albowski
 * @version 5'2020
 */
public class Grundriss extends Moebel
{

  /**
   * Erzeuge einen neuen Grundriss
   */
    public Grundriss(int x,int y,String f,String ff,int o,int b,int t)
  {
    xPosition = x;
    yPosition = y;
    orientierung = o;
    farbe = f;
    fuellFarbe = ff;
    istSichtbar = false;
    breite = b;
    tiefe  = t;
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   */
  protected Shape gibAktuelleFigur()
  {
      // definieren
      GeneralPath grundriss = new GeneralPath();
      Shape aussen = new Rectangle2D.Double(0 , 0, breite, tiefe);
      Shape innen = new Rectangle2D.Double(10 , 10, breite-20, tiefe-20);
      Shape fenster = new Rectangle2D.Double(breite/2-40 , tiefe-10, 80, 10);
      Shape tuer = new Rectangle2D.Double(10 , 140, 80, 2);
      Shape tuerbogen = new Arc2D.Double(-70 , 60, 160, 160, 270, 90,
                                         java.awt.geom.Arc2D.OPEN);
      grundriss.append(aussen, false);
      grundriss.append(innen, false);
      grundriss.append(fenster, false);
      grundriss.append(tuer, false);
      grundriss.append(tuerbogen, false);
      return grundriss;
  }
  
}
