import java.awt.Shape;
import java.util.ArrayList;


/**
 * Ein Tisch, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version (20.05.07)
 */
public class Tischgruppe extends Gruppe
{

  /**
   * Erzeuge eine neue Tischgruppe mit einer Standardfarbe an einer
   * Standardposition.
   * anzahl ist die Zahl der Stuehle, die an die Laengsseite passen.
   */
    public Tischgruppe(int anzahl)
  {
    super();
    if (anzahl>5) anzahl=5;
    breite = 40+10+10+anzahl*(40+10)+10+40;
    tiefe  = 40+10+60+10+40;
    fuegeHinzu(new Tisch(50, 50, farbe, orientierung, breite-100, tiefe-100));
    fuegeHinzu(new Stuhl(0, 60, farbe, orientierung+270, 40, 40));
    fuegeHinzu(new Stuhl(breite-40, 60, farbe, orientierung+90, 40, 40));
    for (int i=0;i<anzahl;i++){
        fuegeHinzu(new Stuhl(60+i*50, 0, farbe, orientierung, 40, 40));
        fuegeHinzu(new Stuhl(60+i*50, 120, farbe, orientierung+180, 40, 40));
    }
  }
  
}
