import java.awt.Shape;
import java.awt.geom.GeneralPath;


/**
 * Ein Stuhl, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version 1.3  (22.01.05)
 */
public class Stuhl extends Moebel
{

  /**
   * Erzeuge einen neuen Stuhl mit einer Standardfarbe und Standardgroesse
   * an einer Standardposition.
   */
    public Stuhl(int x,int y,String f,int o,int b,int t)
  {
    xPosition = x;
    yPosition = y;
    orientierung = o;
    farbe = f;
    istSichtbar = false;
    breite = b;
    tiefe  = t;
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   */
  protected Shape gibAktuelleFigur()
  {
      // definieren
      GeneralPath stuhl = new GeneralPath();
      stuhl.moveTo(0 , 0);
      stuhl.lineTo(breite, 0);
      stuhl.lineTo(breite+(breite/20+1), tiefe);
      stuhl.lineTo(-(breite/20+1), tiefe);
      stuhl.lineTo(0 , 0);
      //Das ist die Umrandung. Das Stuhl bekommt noch eine Lehne
      stuhl.moveTo(0 , (breite/10+1));
      stuhl.lineTo(breite, (breite/10+1));
      
      return  transformiere(stuhl);
  }
  
}
