import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.ArrayList;
import java.util.Iterator;

import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.EOFException;

/**
 * Moeblierungsklase, die selbst nur eine Sammlung darstellt.
 * sollte wohl besser nicht von Moebel erben!
 * 
 * @author Claus Albowski
 * @version (20.05.07)
 */
public class Moeblierung
{
   private ArrayList<Moebel> moebelListe;
   private Iterator<Moebel> iterator;
   private Moebel aktuellesMoebel;
   private String farbeAktuellesMoebel;

  /**
   * Erzeuge eine neue Moeblierung mit einer Standardfarbe an einer
   * Standardposition.
   */
    public Moeblierung()
  {
    moebelListe = new ArrayList();
    iterator = null;
    aktuellesMoebel = null;
    farbeAktuellesMoebel = null;
  }

  /**
   * sichert und loescht die Darstellung.
   */ 
    public void sichernUndLoeschen()
    throws IOException {
        sichern();
        loescheAlle();
        liste = new ArrayList();
    }  
    
  /**
   * holt und stellt alle dar.
   */
  public void holenUndZeigen()
  throws ClassNotFoundException, IOException {
      holen();
      zeigeAlle();
    }
  
  private void sichern()
  throws IOException {
    }
    
  /**
   * fuegt ein Moebel hinzu.
   * das aktuelleMoebel wird mit dem Iterator neu gesetzt.
   */
  public void fuegeHinzu(Moebel moebel){
      if (aktuellesMoebel!=null) aktuellesMoebel.aendereFarbe(farbeAktuellesMoebel);
      moebelListe.add(moebel);
      aktuellesMoebel=moebel;
      farbeAktuellesMoebel=(String)moebel.gibDaten().get(2);
      moebel.aendereFarbe("grau");
      moebel.zeige();
      iterator=moebelListe.iterator();
      while (!moebel.equals(aktuellesMoebel)) iterator.next();
  }

  /**
   * entfernt ein Moebel.
   */
  public void entferne(Moebel moebel){
      moebel.verberge();
      moebelListe.remove(moebel);
      aktuellesMoebel=null;
      zumAnfang();
  }

  /**
   * setzt den Iterator zurck.
   */
  public void zumAnfang(){
      if (aktuellesMoebel!=null) aktuellesMoebel.aendereFarbe(farbeAktuellesMoebel);
      iterator=moebelListe.iterator();
      aktuellesMoebel=next();
  }

  /**
   * prft, ob es noch ein nachfolgendes Mbel gibt.
   */
  public boolean hasNext(){
      return iterator.hasNext();
  }

  /**
   * gibt ein Moebel zurck und setzt den Zeiger weiter.
   * am letzten Element wird weiter das letzte zurck gegeben.
   */
  public Moebel next(){
      if (iterator.hasNext()) {
        if (aktuellesMoebel!=null) aktuellesMoebel.aendereFarbe(farbeAktuellesMoebel);
        aktuellesMoebel = iterator.next();
        farbeAktuellesMoebel=(String)aktuellesMoebel.gibDaten().get(2);
        aktuellesMoebel.aendereFarbe("grau");
      }
      return aktuellesMoebel;
  }
  
  
  /**
   * setzt die Daten des aktuellen Mbels neu.
   */
  public void update(String x, String y, String f, String o, String b, String t)
  {
      farbeAktuellesMoebel=f;
      aktuellesMoebel.update(
                             new Integer(x),
                             new Integer(y),
                             "grau",
                             new Integer(o),
                             new Integer(b),
                             new Integer(t));
  }
  
  /**
   * die folgenden Methoden geben die Daten des aktuellen Mbels zurck.
   */
  protected String gibX(){
    if (aktuellesMoebel!=null)
    return aktuellesMoebel.gibDaten().get(0).toString();
    else return "";
  }
  protected String gibY(){
    if (aktuellesMoebel!=null)
    return aktuellesMoebel.gibDaten().get(1).toString();
    else return "";
  }
  protected String gibFarbe(){
    if (aktuellesMoebel!=null)
    return farbeAktuellesMoebel;
    else return "";
  }
  protected String gibOrientierung(){
    if (aktuellesMoebel!=null)
    return aktuellesMoebel.gibDaten().get(3).toString();
    else return "";
  }
  protected String gibBreite(){
    if (aktuellesMoebel!=null)
    return aktuellesMoebel.gibDaten().get(4).toString();
    else return "";
  }
  protected String gibTiefe(){
    return aktuellesMoebel.gibDaten().get(5).toString();
  }



}
