import java.util.ArrayList;
import java.util.Iterator;

import java.awt.event.*;

public class RaumplanerController{

  private static ArrayList<Moebel> alleMoebel = new ArrayList<Moebel>();
  private static Moebel ausgewaehlt,mausWahl;
  private static Iterator<Moebel> it;
  private Moebel grundriss;
  private int xMaus=0;
  private int yMaus=0;  // sichert die letzte Mausposition

  public RaumplanerController(RaumplanerGui gui){
    ausgewaehlt = null;
    it=null;
    erzeugeListener();
    startDarstellung();
  }
  
  private void startDarstellung() {
    grundriss = new Grundriss(30, 30, "schwarz", "", 0, 370, 400);
    grundriss.zeige();
    //neuesMoebel("Stuhl");
    //neuesMoebel("Tisch");
    //neuesMoebel("EinzelBett");
    }

  public void neuesMoebel(String typ) {
    Moebel moebel = null;
    if (typ=="Tisch") moebel=new Tisch(160, 350,"schwarz","braun",0,120,60);
    else if (typ=="Stuhl") moebel=new Stuhl(200,300,"schwarz","braun",0,40,40);
    else if (typ=="EinzelBett") moebel=new EinzelBett(50,50,"schwarz","gelb",0,190,90);
    else return;
    auswahlBeenden();
    alleMoebel.add(moebel);
    moebel.zeige();
  }
  
  public void auswahlBeenden(){
    markierungLoeschen();
    ausgewaehlt = null;
    it=null;
  }
  
  public Moebel gibAuswahl() {
      return ausgewaehlt;
    }
  
  public void markierungLoeschen(){
    if (ausgewaehlt!=null) {
      ausgewaehlt.verberge();
      ausgewaehlt.setzeAuswahl(false);
      ausgewaehlt.zeige();
    }
  }

  public Moebel auswahl(){
    // zuerst alte Markierung loeschen:
    markierungLoeschen();
    // neu auswaehlen:
    if (it==null) it=alleMoebel.iterator();
    if (it.hasNext()) ausgewaehlt=it.next();
    else auswahlBeenden();
    // neu markieren:
    if (ausgewaehlt!=null) {
      ausgewaehlt.verberge();
      ausgewaehlt.setzeAuswahl(true);
      ausgewaehlt.zeige();
    }
    return ausgewaehlt;
  }
  
  public static void verschiebe(){
    if (ausgewaehlt!=null)
    ausgewaehlt.bewegeHorizontal(50);
  }
  
  public void verberge() {
    if (ausgewaehlt!=null) ausgewaehlt.verberge();
    }
  
  public void zeige() {
    if (ausgewaehlt!=null)  ausgewaehlt.zeige();
    }
  
  public void loesche() {
    if (ausgewaehlt!=null) {
        int index=alleMoebel.indexOf(ausgewaehlt);
        ausgewaehlt.verberge();
        ausgewaehlt=null;
        ArrayList<Moebel> neu = new ArrayList();
        for (int i=0;i<alleMoebel.size();i++)
        if (i!=index) neu.add(alleMoebel.get(i));
        alleMoebel=neu;
    }
    }
  
  private void erzeugeListener(){
    Leinwand leinwand = Leinwand.gibLeinwand();
    leinwand.gibZeichenflaeche().addMouseListener(new MouseAdapter(){
      public void mouseClicked(MouseEvent e){
        for (Iterator<Moebel> it=alleMoebel.iterator(); it.hasNext();) {
          mausWahl=it.next();
          if (mausWahl.transformiere(mausWahl.gibAktuelleFigur()).contains(e.getX(), e.getY())) {
            markierungLoeschen();
            ausgewaehlt=mausWahl;
            ausgewaehlt.verberge();
            ausgewaehlt.setzeAuswahl(true);
            ausgewaehlt.zeige();
          }
        }
      }
        
      public void mousePressed(MouseEvent e) {
        for (Iterator<Moebel> it=alleMoebel.iterator(); it.hasNext();) {
          mausWahl=it.next();
          if (mausWahl.transformiere(mausWahl.gibAktuelleFigur()).contains(e.getX(), e.getY())) {
            markierungLoeschen();
            ausgewaehlt=mausWahl;
            ausgewaehlt.setzeAuswahl(true);
            xMaus=e.getX();
            yMaus=e.getY();
            }
          }
      }
      public void mouseReleased(MouseEvent e){
         auswahlBeenden();
         xMaus=0;
         yMaus=0;
    }
    });
    
    leinwand.gibZeichenflaeche().addMouseMotionListener(new MouseMotionAdapter(){
      public void mouseDragged(MouseEvent e){
        if (ausgewaehlt==null) return;
        int dx = e.getX() - xMaus;
        int dy = e.getY() - yMaus;
        ausgewaehlt.bewegeHorizontal(dx);
        ausgewaehlt.bewegeVertikal(dy);
        xMaus = e.getX();
        yMaus = e.getY();
      }
    });
  }
  
  
}