import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import java.io.*;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * Beschreibung
 *
 * @version 1.0 vom 10.05.2020
 * @author 
 */

public class RaumplanerGui extends JFrame {
  // Anfang Attribute
  private static RaumplanerController controller;
  private static RaumplanerGui gui;

//  private Canvas canvas1 = new Canvas();
  private JPanel flaeche; //= new JPanel();
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenuDatei = new JMenu("Datei");
  private JMenuItem jBeendenItem = new JMenuItem("Beenden");
  private JMenu jMenuNeu = new JMenu("Neu");
  private JMenuItem jStuhlItem = new JMenuItem("neuer Stuhl");
  private JMenuItem jTischItem = new JMenuItem("neuer Tisch");
  private JMenuItem jEinzelBettItem = new JMenuItem("neues Einzelbett");
  private JMenu jMenuAuswahl = new JMenu("Auswahl");
  private JMenuItem jWaehleItem = new JMenuItem("waehle naechstes");
  private JMenuItem jVerbergeItem = new JMenuItem("verberge");
  private JMenuItem jZeigeItem = new JMenuItem("zeige");
  private JMenuItem jLoescheItem = new JMenuItem("loesche");
  private JMenu jMenuBearbeiten = new JMenu("Bearbeiten");
  private JMenuItem jHorizontalItem = new JMenuItem("bewege horizontal");
  private JMenuItem jVertikalItem = new JMenuItem("bewege vertikal");
  private JMenuItem jDreheItem = new JMenuItem("drehe");
  private JMenuItem jFarbeItem = new JMenuItem("aendere Farbe");
  private JMenuItem jFuellFarbeItem = new JMenuItem("aendere Fuellfarbe");
  
  private JMenu jMenuBild = new JMenu("Bild");
  private JMenuItem jBildItem = new JMenuItem("Bild speichern");
  private JFileChooser jFileChooserSave = new JFileChooser();
  // Ende Attribute
  
  public RaumplanerGui(String title) { 
    
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 500; 
    int frameHeight = 500;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setTitle("Raumplaner-Gui");
    setResizable(false);
    // Anfang Komponenten
    
    Leinwand leinwand=Leinwand.gibLeinwand(this);
    Container cp = getContentPane();
    cp.setLayout(null);
    jMenuBar1.add(jMenuDatei);
    jMenuDatei.add(jBeendenItem);
    
    jMenuBar1.add(jMenuNeu);
    jMenuNeu.add(jStuhlItem);
    jMenuNeu.add(jTischItem);
    jMenuNeu.add(jEinzelBettItem);
    
    jMenuBar1.add(jMenuAuswahl);
    jMenuAuswahl.add(jWaehleItem);
    jMenuAuswahl.add(jVerbergeItem);
    jMenuAuswahl.add(jZeigeItem);
    jMenuAuswahl.add(jLoescheItem);
    
    jMenuBar1.add(jMenuBearbeiten);
    jMenuBearbeiten.add(jHorizontalItem);
    jMenuBearbeiten.add(jVertikalItem);
    jMenuBearbeiten.add(jDreheItem);
    jMenuBearbeiten.add(jFarbeItem);
    jMenuBearbeiten.add(jFuellFarbeItem);
    
    jMenuBar1.add(jMenuBild);
    jMenuBild.add(jBildItem);
    
    jBeendenItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            beendenAktion();}
    });
    jStuhlItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            neuAktion("Stuhl");}
    });
    jTischItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            neuAktion("Tisch");}
    });
    jEinzelBettItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            neuAktion("EinzelBett");}
    });

    
    jWaehleItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            controller.auswahl();}
    });
    
    jVerbergeItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            controller.verberge();}
    });
    
    jZeigeItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            controller.zeige();}
    });
    
    jLoescheItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            controller.loesche();}
    });
    
    jHorizontalItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            if (controller.gibAuswahl()==null) {
                ausgabe("erst auswaehlen !");
                return;
            }
            int weite;
            String eingabe = JOptionPane.showInputDialog(null,
            "Geben Sie die Weite ein","Eingabe",JOptionPane.PLAIN_MESSAGE);
            try {weite=Integer.parseInt(eingabe);
                Moebel auswahl = controller.gibAuswahl();
                if (auswahl!=null) auswahl.bewegeHorizontal(weite);
                }
            catch (NumberFormatException e)
            {ausgabe("ganzzahligen Wert eingeben!");}
        }
    });
    
    jVertikalItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            if (controller.gibAuswahl()==null) {
                ausgabe("erst auswaehlen !");
                return;
            }
            int weite;
            String eingabe = JOptionPane.showInputDialog(null,
            "Geben Sie die Weite ein","Eingabe",JOptionPane.PLAIN_MESSAGE);
            try {weite=Integer.parseInt(eingabe);
                Moebel auswahl = controller.gibAuswahl();
                if (auswahl!=null) auswahl.bewegeVertikal(weite);
                }
            catch (NumberFormatException e)
            {ausgabe("ganzzahligen Wert eingeben!");}
        }
    });

    jDreheItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            if (controller.gibAuswahl()==null) {
                ausgabe("erst auswaehlen !");
                return;
            }
             int winkel;
            String eingabe = JOptionPane.showInputDialog(null,
            "Geben Sie die Weite ein","Eingabe",JOptionPane.PLAIN_MESSAGE);
            try {winkel=Integer.parseInt(eingabe);
                Moebel auswahl = controller.gibAuswahl();
                if (auswahl!=null) auswahl.drehe(winkel);
                }
            catch (NumberFormatException e)
            {ausgabe("ganzzahligen Wert eingeben!");}
        }
   });
    jFarbeItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            if (controller.gibAuswahl()==null) {
                ausgabe("erst auswaehlen !");
                return;
            }
            String eingabe = JOptionPane.showInputDialog(null,
            "Farbnamen Rand","Eingabe",JOptionPane.PLAIN_MESSAGE);
            Moebel auswahl = controller.gibAuswahl();
            if (auswahl!=null) auswahl.aendereFarbe(eingabe);
        }
    });
    jFuellFarbeItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            if (controller.gibAuswahl()==null) {
                ausgabe("erst auswaehlen !");
                return;
            }
            String eingabe = JOptionPane.showInputDialog(null,
            "Farbnamen Fuellung","Eingabe",JOptionPane.PLAIN_MESSAGE);
            Moebel auswahl = controller.gibAuswahl();
            if (auswahl!=null) auswahl.aendereFuellFarbe(eingabe);
        }
    });
    
    jBildItem.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            String dateiname=jFileChooserSave_saveFile();
            if (dateiname!=null)
            Leinwand.gibLeinwand().bildSpeichern(dateiname);
        }
    });
    
    setJMenuBar(jMenuBar1);
    // Ende Komponenten
    
    setVisible(true);
  } // end of public Gui
  
  // Anfang Methoden
  // /**
   // * alternativ dispatcher fuer die Ereignisse
   // * wenn die Klasse ActionListener implementiert
   // */
  // public void actionPerformed(ActionEvent e) {
        // JMenuItem source = (JMenuItem)(e.getSource());
        // if (source.getText()=="Beenden") beendenAktion();
        // else if (source.getText()=="Stuhl") neuAktion("Stuhl");
    // }

    private void beendenAktion() {
        System.exit(0);
    }
    
    private void neuAktion(String name) {
        controller.neuesMoebel(name);
    }
    
    private void ausgabe(String text) {
        JOptionPane.showMessageDialog(null,
        text,
        "ACHTUNG",
        JOptionPane.WARNING_MESSAGE);
    }

  public String jFileChooserSave_saveFile() {
   FileNameExtensionFilter filter = new FileNameExtensionFilter(
        "JPEG file", "jpg", "jpeg");
    jFileChooserSave.setFileFilter(filter);
    if (jFileChooserSave.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jFileChooserSave.getSelectedFile().getName();
    } else {
      return null;
    }
  }

  
  public static void main(String[] args) {
    gui = new RaumplanerGui("RaumplanerGui");
  // Ende Methoden2
    controller= new RaumplanerController(gui);
  } // end of main
  
  // Ende Methoden
} // end of class Gui

