import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;
import java.awt.geom.GeneralPath;

/**
 * Ein KonferenzTisch, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version 2  (12.05.09)
 */

public class KonferenzTisch extends Moebel
{

  /**
   * Erzeuge einen neuen KonferenzTisch mit einer Standardfarbe an einer
   * Standardposition.
   */
    public KonferenzTisch(int x,int y,String f,int o,int elementTiefe)
  {
    xPosition = x;
    yPosition = y;
    orientierung = o;
    farbe = f;
    istSichtbar = false;
    breite = 3*elementTiefe;
    tiefe  = elementTiefe;
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   */
  protected Shape gibAktuelleFigur()
  {
      GeneralPath konferenzTisch = new GeneralPath();
      konferenzTisch.moveTo(0,0);
      konferenzTisch.lineTo(breite, 0);
      konferenzTisch.lineTo(breite-tiefe, tiefe);
      konferenzTisch.lineTo(tiefe, tiefe);
      konferenzTisch.lineTo(0, 0);
      return konferenzTisch;
  }
  
}
