import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.ArrayList;
import java.util.Iterator;


/**
 * Moeblierungsklase, die selbst nur eine Sammlung darstellt.
 * sollte wohl besser nicht von Moebel erben!
 * 
 * @author Claus Albowski
 * @version (20.05.07)
 */
public class Moeblierung
{
   private ArrayList<Moebel> moebelListe;
   private Iterator<Moebel> iterator;
   private Moebel aktuellesMoebel;

  /**
   * Erzeuge eine neue Moeblierung mit einer Standardfarbe an einer
   * Standardposition.
   */
    public Moeblierung()
  {
    moebelListe = new ArrayList();
    iterator = null;
    aktuellesMoebel = null;
  }
  
  /**
   * fuegt ein Moebel hinzu.
   * das aktuelleMoebel wird mit dem Iterator neu gesetzt.
   */
  public void fuegeHinzu(Moebel moebel){
      moebelListe.add(moebel);
      moebel.zeige();
      zumAnfang();
      while (!moebel.equals(aktuellesMoebel)) next();
  }

  /**
   * entfernt ein Moebel.
   */
  public void entferne(Moebel moebel){
      moebel.verberge();
      zumAnfang();
      moebelListe.remove(moebel);
  }

  /**
   * setzt den Iterator zurck.
   */
  public void zumAnfang(){
      iterator=moebelListe.iterator();
      aktuellesMoebel=next();
  }

  /**
   * prft, ob es noch ein nachfolgendes Mbel gibt.
   */
  public boolean hasNext(Moebel moebel){
      return iterator.hasNext();
  }

  /**
   * gibt ein Moebel zurck und setzt den Zeiger weiter.
   * am letzten Element wird weiter das letzte zurck gegeben.
   */
  public Moebel next(){
      if (iterator.hasNext()) aktuellesMoebel = iterator.next();
      return aktuellesMoebel;
  }
  
  
  /**
   * setzt die Daten des Mbels neu.
   */
  public void update(String x, String y, String f, String o, String b, String t)
  {
      aktuellesMoebel.update(
                             new Integer(x),
                             new Integer(y),
                             f,
                             new Integer(o),
                             new Integer(b),
                             new Integer(t));
  }
  
  /**
   * die folgenden Methoden geben die Daten des aktuellen Mbels zurck.
   */
  protected String gibX(){
    return aktuellesMoebel.gibDaten().get(0).toString();
  }
  protected String gibY(){
    return aktuellesMoebel.gibDaten().get(1).toString();
  }
  protected String gibFarbe(){
    return (String)aktuellesMoebel.gibDaten().get(2);
  }
  protected String gibOrientierung(){
    return aktuellesMoebel.gibDaten().get(3).toString();
  }
  protected String gibBreite(){
    return aktuellesMoebel.gibDaten().get(4).toString();
  }
  protected String gibTiefe(){
    return aktuellesMoebel.gibDaten().get(5).toString();
  }



}
