import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Ellipse2D;

/**
 * Ein Tisch, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version 2021
 */
public class Tisch extends Moebel
{
    
    /**
     * Erzeuge einen neuen Tisch mit einer Standardfarbe und Standardgroesse
     * an einer Standardposition. (Standardkonstruktor)
     */
    public Tisch()  {
        super(120,50,"rot",0,false,120,100);
    }
    
    /**
     * Erzeuge einen neuen Tisch.
     */
    public Tisch(int xPosition,
                int yPosition,
                String farbe,
                int orientierung,
                int breite,
                int tiefe) {
         super(xPosition,yPosition,farbe,orientierung,false,breite,tiefe);
    }
    
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
     * [ Zum Anzeigen der Attributwerte ber Inspect muss hier die Sichtbarkeit 
     *  auf public gesetzt werden. ]
     */
    protected Shape gibAktuelleFigur()
    {
        int breite=gibBreite();
        int tiefe=gibTiefe();
        Shape tisch = new Ellipse2D.Double(0 , 0, breite, tiefe);
        return transformiere(tisch);
    }
}
